# Copyright © 2023 Neven Sajko

module NumericalErrors

import ..NumericalErrorTypes

const NE = NumericalErrorTypes

numerical_error_unchecked(::NE.AbsoluteError, accurate, approximate) =
  abs(accurate - approximate)

function numerical_error_unchecked(::NE.RelativeError, accurate, approximate)
  (accurate == approximate) && return zero(approximate)
  abs(1 - approximate/accurate)
end

function numerical_error(error_type::NE.NumericalErrorType, accurate, approximate)
  isfinite(accurate) || error("accurate not finite")
  isfinite(approximate) || error("approximate not finite")
  numerical_error_unchecked(error_type, accurate, approximate)
end

end
